import net.dv8tion.jda.api.AccountType;
import net.dv8tion.jda.api.JDABuilder;
import net.dv8tion.jda.api.entities.Activity;
import net.dv8tion.jda.api.entities.Message;
import net.dv8tion.jda.api.entities.MessageChannel;
import net.dv8tion.jda.api.events.message.MessageReceivedEvent;
import net.dv8tion.jda.api.hooks.ListenerAdapter;
import net.dv8tion.jda.api.requests.GatewayIntent;

import javax.security.auth.login.LoginException;

public class Main extends ListenerAdapter {
    //Constructor
public static boolean islogEnabled = false; //default state

    public static void main(String[] args) throws LoginException {
        JDABuilder builder = new JDABuilder(AccountType.BOT);
        JDABuilder.createLight(Constants.TOKEN, GatewayIntent.GUILD_MESSAGES, GatewayIntent.DIRECT_MESSAGES)
                .addEventListeners(new Main())
                .setActivity(Activity.playing(getIsTestingMode()))
                .build();
    }


//    public void onMessageReceived(MessageReceivedEvent event) {
//        System.out.println("Message Received from" + event.getAuthor().getName() + "with the message: " + event.getMessage().getContentDisplay());
//
//        if (event.getMessage().getContentRaw().equals("!test")) {
//            event.getChannel().sendMessage("Hello, Test Complete").queue();
//        }
//    }
//}
//    public static void main(String[] args) throws LoginException {
//        String token = "NzAwMzMxOTgxMjYyODE1MjQy.XphY-w.p51VEReWdh-kvlCNtWmvvFA_aBA";
//        // We only need 2 intents in this bot. We only respond to messages in guilds and private channels.
//        // All other events will be disabled.
//        JDABuilder.createLight(token, GatewayIntent.GUILD_MESSAGES, GatewayIntent.DIRECT_MESSAGES)
//                .addEventListeners(new Main())
//                .setActivity(Activity.playing("Type !ping"))
//                .build();
//    }
//
    @Override
    public void onMessageReceived(MessageReceivedEvent event) {
        Message msg = event.getMessage();
        if(islogEnabled) {  //enables / disables terminal output
            System.out.println("Message Received from " + event.getAuthor().getName() + " with the message: " + msg);
        }
        String content = msg.getContentRaw();
        MessageChannel channel = event.getChannel();
        switch (content) {
            case (Constants.ACTIVATOR + "test"): {
                channel.sendMessage("Test Recieved!").queue();
            }break;

            case(Constants.ACTIVATOR + "cum"): {
                channel.sendMessage("WELCOME TO THE CUM ZONE!").queue();
            } break;

            case (Constants.ACTIVATOR + "pingTime"): {
                long time = System.currentTimeMillis();
                channel.sendMessage("Pong!") /* => RestAction<Message> */
                        .queue(response /* => Message */ -> {
                            response.editMessageFormat("Pong: %d ms", System.currentTimeMillis() - time).queue();
                        });
            }break;

            case (Constants.ACTIVATOR + "c"): {

                long time = System.currentTimeMillis();
                channel.sendMessage("Pong!") /* => RestAction<Message> */
                        .queue(response /* => Message */ -> {
                            response.editMessageFormat("Pong: %d ms", System.currentTimeMillis() - time).queue();
                        });
            }break;

            case (Constants.ACTIVATOR + "u"): {

                long time = System.currentTimeMillis();
                channel.sendMessage("Pong!") /* => RestAction<Message> */
                        .queue(response /* => Message */ -> {
                            response.editMessageFormat("Pong: %d ms", System.currentTimeMillis() - time).queue();
                        });
            }break;

            case (Constants.ACTIVATOR + "m"): {
                long time = System.currentTimeMillis();
                channel.sendMessage("Pong!") /* => RestAction<Message> */
                        .queue(response /* => Message */ -> {
                            response.editMessageFormat("Pong: %d ms", System.currentTimeMillis() - time).queue();
                        });
            }break;

            case(Constants.ACTIVATOR + "disableLog"): {

                if(!islogEnabled)   //checks if logging is already disabled
                    channel.sendMessage("Logging is already Disabled").queue();
                else {
                    islogEnabled = false;
                    channel.sendMessage("Logging is now Disabled").queue();
                }
            }break;

            case(Constants.ACTIVATOR + "enableLog"): {

                if(islogEnabled)  //checks if logging is already enabled
                    channel.sendMessage("Logging is already Enabled").queue();
                else {
                    islogEnabled = true;
                    channel.sendMessage("Logging is now Enabled").queue();
                }
            }break;
            case(Constants.ACTIVATOR + "sudo killBot"): { //currently not working
                System.out.println(event.getAuthor());// debug print

                if(event.getAuthor().equals("ChrisPro Elite")){
                    channel.sendMessage("stopping bot").queue();
                    System.exit(0);

                }
                else{
                    channel.sendMessage("You are not Authorised to use sudo commands").queue();
                }
            }
        }
    }
public static String getIsTestingMode(){
        if(Constants.TESTING_MODE)
            return "TESTING MODE";
        else if(!Constants.TESTING_MODE)
            return (Constants.ACTIVATOR + "to activate bot");
        else
            return "ERROR in Code";
}

//this shit doesnt work
//    public static void sendMessageOnSameChannel(MessageReceivedEvent event, String message){
//        MessageChannel channel = event.getChannel();
//        channel.sendMessage(message).queue();
//    }
//    public static void printMessageStream(MessageReceivedEvent event){
//        Message msg = event.getMessage();
//        System.out.println("Message Received from " + event.getAuthor().getName() + " with the message: " + msg);
//
//    }
}